Index: src/olympusmn.cpp
===================================================================
--- src/olympusmn.cpp	(revision 2980)
+++ src/olympusmn.cpp	(working copy)
@@ -1259,11 +1259,12 @@
             { { 0,  8,  1 }, N_("Olympus Zuiko Digital 70-300mm F4.0-5.6")              },
             { { 0,  8, 16 }, N_("Olympus M.Zuiko Digital ED 75-300mm F4.8-6.7")         },
             { { 0,  9, 16 }, N_("Olympus M.Zuiko Digital 14-42mm F3.5-5.6 II")          },
+            { { 0, 16,  1 }, N_("Kenko Tokina Reflex 300mm F6.3 MF Macro")              },
             { { 0, 16, 16 }, N_("Olympus M.Zuiko Digital ED 12-50mm F3.5-6.3 EZ")       },
             { { 0, 17, 16 }, N_("Olympus M.Zuiko Digital 45mm F1.8")                    },
             { { 0, 18, 16 }, N_("Olympus M.Zuiko Digital ED 60mm F2.8 Macro")           },
             { { 0, 19, 16 }, N_("Olympus M.Zuiko Digital ED 14-42mm F3.5-5.6 II R")     },
-            { { 0, 20, 16 }, N_("Olympus M.Zuiko Digital ED 14-150mm II or 40-150mm R") },
+            { { 0, 20, 16 }, N_("Olympus M.Zuiko Digital ED 40-150mm F4.0-5.6 R")       },
             { { 0, 21,  0 }, N_("Olympus Zuiko Digital ED 7-14mm F4.0")                 },
             { { 0, 21, 16 }, N_("Olympus M.Zuiko Digital ED 75mm F1.8")                 },
             { { 0, 22, 16 }, N_("Olympus M.Zuiko Digital 17mm F1.8")                    },
@@ -1300,20 +1301,25 @@
             { { 2,  1,  0 }, N_("Leica D Vario Elmarit 14-50mm F2.8-3.5 Asph.")         },
             { { 2,  1, 16 }, N_("Lumix G Vario 14-45mm F3.5-5.6 Asph. Mega OIS")        },
             { { 2,  2,  0 }, N_("Leica D Summilux 25mm F1.4 Asph.")                     },
-            { { 2,  2, 16 }, N_("Lumix G Vario 45-200mm F4-5.6 Mega OIS")               },
+            { { 2,  2, 16 }, N_("Lumix G Vario 45-200mm F4.0-5.6 Mega OIS")             },
             { { 2,  3,  0 }, N_("Leica D Vario Elmar 14-50mm F3.8-5.6 Asph. Mega OIS")  },
             { { 2,  3,  1 }, N_("Leica D Vario Elmar 14-50mm F3.8-5.6 Asph.")           },
-            { { 2,  3, 16 }, N_("Lumix G Vario HD 14-140mm F4-5.8 Asph. Mega OIS")      },
+            { { 2,  3, 16 }, N_("Lumix G Vario HD 14-140mm F4.0-5.8 Asph. Mega OIS")    },
             { { 2,  4,  0 }, N_("Leica D Vario Elmar 14-150mm F3.5-5.6")                },
-            { { 2,  4, 16 }, N_("Lumix G Vario 7-14mm F4 Asph.")                        },
+            { { 2,  4, 16 }, N_("Lumix G Vario 7-14mm F4.0 Asph.")                      },
             { { 2,  5, 16 }, N_("Lumix G 20mm F1.7 Asph.")                              },
-            { { 2,  6, 16 }, N_("Leica DG Macro-Elmarit 45mm F2.8")                     },
+            { { 2,  6, 16 }, N_("Leica DG Macro-Elmarit 45mm F2.8 Asph. Mega OIS")      },
+            { { 2,  7, 16 }, N_("Lumix G Vario 14-42mm F3.5-5.6 Asph. Mega OIS")        },
             { { 2,  8, 16 }, N_("Lumix G Fisheye 8mm F3.5")                             },
-            { { 2,  9, 16 }, N_("Lumix G Vario 100-300mm F4.0-5.6 OIS")                 },
+            { { 2,  9, 16 }, N_("Lumix G Vario 100-300mm F4.0-5.6 Mega OIS")            },
             { { 2, 16, 16 }, N_("Lumix G 14mm F2.5 Asph.")                              },
+            { { 2, 17, 16 }, N_("Lumix G 3D 12.5mm F12")                                },
             { { 2, 18, 16 }, N_("Leica DG Summilux 25mm F1.4 Asph.")                    },
-            { { 2, 20, 16 }, N_("Lumix G X Vario PZ 14-42mm F3.5-5.6 ASPH Power OIS")   },
-            { { 2, 21, 16 }, N_("Lumix G X Vario 12-35mm F2.8 ASPH Power OIS")          },
+            { { 2, 19, 16 }, N_("Lumix G X Vario PZ 45-175mm F4.0-5.6 Asph. Power OIS") },
+            { { 2, 20, 16 }, N_("Lumix G X Vario PZ 14-42mm F3.5-5.6 Asph. Power OIS")  },
+            { { 2, 21, 16 }, N_("Lumix G X Vario 12-35mm F2.8 Asph. Power OIS")         },
+            { { 2, 22, 16 }, N_("Lumix G Vario 45-150mm F4.0-5.6 Asph. Mega OIS")       },
+            { { 2, 23, 16 }, N_("Lumix G X Vario 35-100mm F2.8 Power OIS")              },
             { { 3,  1,  0 }, N_("Leica D Vario Elmarit 14-50mm F2.8-3.5 Asph.")         },
             { { 3,  2,  0 }, N_("Leica D Summilux 25mm F1.4 Asph.")                     },
             // End of list marker